{$B-}
Unit treeunit;                       {Carlos Gershenson}
Interface

Uses
	crt,captura2;
Const
        maxkeys=4;
        maxchild=5;
        maxwkeys=5;
        maxwchild=6;
        nokey='';
        no=false;
        yes=true;
        null=-1;
        minkeys=maxkeys div 2;

        arch='patotree.dat';

Type
        patoreg=record
          key:string;
          pos:longint;
          bor:boolean;
        end;
        BTPage=record
          keycount:integer;
          r:array[1..maxkeys] of patoreg;
          child:array[1..maxchild] of integer;
        end;
Var

	btfd:file of BTPage;
        promoted:boolean;
        root,promorrn{,minkeys,pagesize}:integer;
        promokey,key:patoreg;
        g:char;

Procedure insertarTree(arch:string;key:patoreg);
Procedure BuscarTree(arch,key:string;var raiz:P_Dato);
Procedure MostrarTree(arch:string;var raiz:P_DAto);
function  ITS(I: Longint): String;
function  ITN(S:string): longint;


Implementation

function ITS(I: Longint): String;
var
 S: string[11];
begin
 Str(I, S);
 ITS := S;
end;

function ITN(S:string): longint;
var
 I: longint;code:integer;
begin
 Val(S,I,code);
 ITN := I;
end;

function FileExists(FileName: String): Boolean;
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;

Function btopen(arch:string):boolean;

begin
        assign(btfd,arch);
        If FileExists(arch) then
        begin
          Reset(btfd);
          btopen:=true;
        end
        else
          btopen:=false;
end;

Function compara(a,b:patoreg):boolean;

begin
        If (a.key=b.key)and(a.pos=b.pos)and(a.bor=b.bor) then
          compara:=true
        else
          compara:=false;
end;

Function getroot:integer;

var
        root:BTPage;

begin
        seek(btfd,0);
        if not eof (btfd) then
        begin
          read(btfd,root);
          getroot:=root.keycount;
        end
        else
          Writeln('Error: No se encontro la raiz');
end;

Function getpage:integer;

begin
        getpage:=filesize(btfd);
end;

Procedure pageinit(var ppage:BTPage);

var
        j:integer;

begin
        For j:=1 to maxkeys do
        begin
          ppage.r[j].key:=nokey;
          ppage.r[j].bor:=false;
          ppage.child[j]:=null;
        end;
        ppage.child[maxkeys+1]:=null;
end;

Procedure putroot(root:integer);

var
        rootrrn:BTPage;

begin
        seek(btfd,0);
        rootrrn.keycount:=root;
        pageinit(rootrrn);
        write(btfd,rootrrn);
end;

Procedure btread(rrn:integer;var pageptr:BTPage);
begin
        seek(btfd,rrn);
        read(btfd,pageptr);
end;

Procedure btwrite(rrn:integer; pageptr:BTPage);
begin
        seek(btfd,rrn);
        write(btfd,pageptr);
end;

Function createroot(key:patoreg;left,right:integer):integer;

var
        page:BTPage;
        rrn:integer;

begin
        rrn:=getpage;
        pageinit(page);
        page.r[1]:=key;
        page.child[1]:=left;
        page.child[2]:=right;
        page.keycount:=1;
        btwrite(rrn,page);
        putroot(rrn);
        createroot:=rrn;
end;

Function createtree(key:patoreg):integer;

var
        rootrrn:integer;

begin
        rewrite(btfd);
        rootrrn:=getpage;
        putroot(rootrrn);
        createtree:=createroot(key,null,null);
end;

Function searchnode(key:patoreg;ppage:BTPage;var pos:integer):boolean;

var
        i:integer;

begin
        i:=1;
        while (i<=ppage.keycount)and(key.key>ppage.r[i].key)do
          i:=i+1;
        pos:=i;
        if (pos<=ppage.keycount)and(compara(key,ppage.r[pos]))then
          searchnode:=yes
        else
          searchnode:=no;
end;

Procedure insinpage(key:patoreg;rchild:integer;var ppage:BTPage);

var
        i:integer;

begin
        i:=ppage.keycount+1;
        while (key.key<ppage.r[i-1].key)and(i>1)do
        begin
          ppage.r[i].key:=ppage.r[i-1].key;
          ppage.child[i+1]:=ppage.child[i];
          i:=i-1;
        end;
        ppage.keycount:=ppage.keycount+1;
        ppage.r[i].key:=key.key;
        ppage.child[i+1]:=rchild;
end;

Procedure split(key:patoreg;rchild:integer;var poldpage:BTPage;var promokey:patoreg;
          var promorchild:integer;var pnewpage:BTPage);

var
        i:integer;
        workkeys:array[1..maxwkeys]of patoreg;
        workch:array[1..maxwchild]of integer;

begin
        for i:=1 to maxkeys do
        begin
          workkeys[i]:=poldpage.r[i];
          workch[i]:=poldpage.child[i];
        end;
        workch[maxkeys+1]:=poldpage.child[maxkeys+1];
        i:=maxkeys+1;
        While (key.key<workkeys[i-1].key)and(i>1) do
        begin
          workkeys[i]:=workkeys[i-1];
          workch[i+1]:=workch[i];
          i:=i-1;
        end;
        workkeys[i]:=key;
        workch[i+1]:=rchild;
        promorchild:=getpage;
        pageinit(pnewpage);
        for i:=1 to minkeys do
        begin
          poldpage.r[i]:=workkeys[i];
          poldpage.child[i]:=workch[i];
          pnewpage.r[i]:=workkeys[i+1+minkeys];
          pnewpage.child[i]:=workch[i+1+minkeys];
          poldpage.r[i+minkeys].key:=nokey;
          poldpage.child[i+1+minkeys]:=null;
        end;
        poldpage.child[1+minkeys]:=workch[minkeys+1];
        if odd(maxkeys) then
        begin
          pnewpage.r[minkeys+1]:=workkeys[maxwkeys];
          pnewpage.child[minkeys+2]:=workch[maxwchild];
          pnewpage.child[minkeys+1]:=workch[maxwchild-1];
        end
        else
        begin
          pnewpage.child[minkeys+1]:=workch[maxwchild];
          pnewpage.keycount:=maxkeys-minkeys;
          poldpage.keycount:=minkeys;
          promokey:=workkeys[minkeys+1];
        end;

end;


Function insert(rrn:integer;key:patoreg;var promorchild:integer;var promokey:patoreg):boolean;

Var
        page,newpage:BTPage;
        found,promoted:boolean;
        pos,pbrrn:integer;
        pbkey:patoreg;

Begin
     If rrn=null then
     begin
       promokey:=key;
       promorchild:=null;
       insert:=yes;
     end
     else
     begin
       btread(rrn,page);
       found:=searchnode(key,page,pos);
       if found then
       begin
         writeln('Error: la llave ya existe');
         insert:=no;
       end
       else
       begin
         promoted:=insert(page.child[pos],key,pbrrn,pbkey);
         if not promoted then
           insert:=no
         else
         begin
           If (page.keycount<maxkeys)then
           begin
             insinpage(pbkey,pbrrn,page);
             btwrite(rrn,page);
             insert:=no;
           end
           else
           begin
             split(pbkey,pbrrn,page,promokey,promorchild,newpage);
             btwrite(rrn,page);
             btwrite(promorchild,newpage);
             insert:=yes;
           end;
         end;
       end;
     end;
end;

Procedure insertarTree(arch:string;key:patoreg);

var car:char;

begin
     If btopen(arch) then
       root:=getroot
     else
       root:=createtree(key);
     promoted:=insert(root,key,promorrn,promokey);
     If promoted then
       root:=createroot(promokey,root,promorrn);
     close(btfd);
end;

Procedure BuscarTree(arch,key:string;var raiz:P_Dato);

var
        pos,i,fs:integer;
        bt:BTPage;
        t:P_Dato;

begin
     If btopen(arch) then
     begin
       {new(raiz);
       raiz^.s_dat:='';
       raiz^.s_num:=0;
       raiz^.sig:=nil;
       raiz^.ant:=nil;
       }

       raiz:=nil;

       t:=raiz;
       pos:=0;
       fs:=(filesize(btfd));
       while (pos<fs) do
       begin
         inc(pos);
         read(btfd,bt);
         For i:=1 to maxkeys do
           If (key = bt.r[i].key)and(bt.r[i].bor=false) then
             begin
               t^.s_dat:=key;
               t^.s_num:=(bt.r[i].pos);
               t^.sig:=nil;
               t^.ant:=nil;
               insertar_nodo_uncap(raiz,t);
             end;
       end;
       Close(btfd);
     end
end;

Procedure BuscarTreePos(arch:string;posi:longint);

var
        pos,i,fs:integer;
        bt:BTPage;
        found,primera:boolean;

begin
     If btopen(arch) then
     begin
       pos:=0;
       found:=false;
       fs:=(filesize(btfd));
       while (pos<fs)and(found=false) do
       begin
         inc(pos);
         read(btfd,bt);
         For i:=1 to maxkeys do
           If (posi = bt.r[i].pos)and(bt.r[i].bor=false) then
             begin
               t^.s_dat:=key;
               t^.s_num:=(bt.r[i].pos);
               t^.sig:=nil;
               t^.ant:=nil;
               insertar_nodo_uncap(raiz,t);
             end;
       end;
       Close(btfd);
     end
end;


Procedure MostrarTree(arch:string;var raiz:P_DAto);

var
        key:string;
        fs:integer;
        bt:BTPage;
        t:P_Dato;

Procedure search(root:integer; b:BTPage);
var
        j,k:integer;
        leaf:boolean;

begin
     seek(btfd,root);
     read(btfd,b);
     leaf:=true;
     For j:=1 to maxchild do
     begin
       If b.child[j]<>-1 then
       begin
         search(b.child[j],b);
         if j<> maxchild then
            If b.r[j].key<>nokey then
            begin
              t^.s_dat:=bt.r[j].key;
              t^.s_num:=(bt.r[j].pos);
              t^.sig:=nil;
              t^.ant:=nil;
              insertar_nodo_uncap(raiz,t);
            end;
         leaf:=false;
       end;
     end;
     If leaf then
         For k:=1 to maxkeys do
           If b.r[k].key<>nokey then
            begin
              t^.s_dat:=bt.r[k].key;
              t^.s_num:=(bt.r[k].pos);
              t^.sig:=nil;
              t^.ant:=nil;
              insertar_nodo_uncap(raiz,t);
            end;

end;

begin
     If btopen(arch) then
     begin
       raiz:=nil;

       t:=raiz;
       root:=getroot;
       search(root,bt);
     end;
end;

{Begin
     clrscr;
     minkeys:=maxkeys div 2;
     pagesize:=sizeof(BTPage);
     If btopen then
       root:=getroot
     else
       root:=createtree;
     Repeat
       clrscr;
       Writeln('1)Insertar');
       Writeln('2)Buscar');
       Writeln('3)Mostrar');
       Writeln('4)Salida');
       repeat g:=readkey until g in ['1'..'4'];
       Case g of
         '1':insertar;
         '2':buscar;
         '3':mostrar;
       end;
     until g='4';
     close(btfd);}
End.
