Unit UtMouV04;{Armando A. Franyuti Guzmn}
              {Utileria del Mouse Ver. 03}
Interface

Uses Dos;
Var  Reg:Registers;

Procedure RatonRes;
Procedure RatonOff;
Procedure RatonOn;
{---------------- Fondos -----------------}
Procedure Fondo(xi,yi,xf,yf,B,E,Cs,Ci,Cb:Integer);
{--------- Botones con Cadenas -----------}
Procedure BotonOff(pC:String;Xi,Yi,pA,pH,pS:Integer);
Function  BotonExe(fC:String;Xi,Yi,fA,fH,fS,ft:Integer):Byte;
{----- Activa los graficos y el MOUSE ----}
Procedure IniUtMouV04;
{---------- Mascaras del MOUSE -----------}
Procedure FaceMouse;
Procedure ArrowMouse;
Procedure CursorMouse;
Procedure HandMouse;
Procedure LoepMouse;
Procedure CruzMouse;

Implementation

Uses Crt,Graph;

Procedure RatonRes;{------------------ Raton Reset-------------------}
Begin
  Reg.cx:=$00;
  Reg.dx:=$00;
End;{----------------------------------------------------------------}

Procedure RatonOff;{------------------ Raton Apagado ----------------}
Begin
     reg.ax:=$02;
     intr($33,reg);
End;{----------------------------------------------------------------}

Procedure RatonOn;{------------------- Raton Encendido --------------}
Begin
     reg.ax:=$01;
     intr($33,reg);
End;{----------------------------------------------------------------}

{---------------------- Barra con bordes en desnibel ----------------}
Procedure Fondo(xi,yi,xf,yf,B,E,Cs,Ci,Cb:Integer);
Var n:Integer;
Begin
     SetFillStyle(E,Cb);
     Bar(xi,yi,xf,yf);
     SetColor(Cs);
     For n:=0 to B do Line(xi,yi+n,xf-n,yi+n);
     For n:=0 to B do Line(xi+n,yi,xi+n,yf-n);
     SetColor(Ci);
     For n:=0 to B do Line(xi+n,yf-n,xf,yf-n);
     For n:=0 to B do Line(xf-n,yi+n,xf-n,yf);
End;{----------------------------------------------------------------}

{--------------------------- Boton inactivo -------------------------}
Procedure BotonOff(pC:String;Xi,Yi,pA,pH,pS:Integer);
Var
  Xf,Yf,fcont:Integer;
Begin
  Xf:=Xi+(Length(pC)*8)-2;
  Yf:=Yi+6;
  SetFillStyle(1, 7);
  Bar(Xi-pA,Yi-pH,Xf+pA,Yf+pH);
  SetColor(0);
  Rectangle(Xi-pA,Yi-pH,Xf+pA,Yf+pH);
  OutTextXY(xi,yi,pC);
  SetColor(15);
  For fcont:=1 to pS do
    Begin
      Line(Xi-pA+fcont,Yi-pH+fcont,Xf+pA-fcont,Yi-pH+fcont);
      Line(Xi-pA+fcont,Yi-pH+fcont,Xi-pA+fcont,Yf+pH-fcont);
    End;
  SetColor(8);
  For fcont:=1 to pS do
    Begin
      Line(Xi-pA+fcont,Yf+pH-fcont,Xf+pA-fcont,Yf+pH-fcont);
      Line(Xf+pA-fcont,Yi-pH+fcont,Xf+pA-fcont,Yf+pH-fcont);
    End;
End;{----------------------------------------------------------------}

{--------------------------- Boton activo ---------------------------}
Procedure pON(pC:String;Xi,Yi,pA,pH,pS:Integer);
Var
  Xf,Yf,fcont:Integer;
Begin
  Xf:=Xi+(Length(pC)*8)-2;
  Yf:=Yi+6;
  SetFillStyle(1, 7);
  Bar(Xi-pA,Yi-pH,Xf+pA,Yf+pH);
  SetColor(0);
  OutTextXY(xi+1,yi+1,pC);
  SetColor(8);
  For fcont:=1 to pS+1 do
    Begin
      Line(Xi-pA+fcont,Yi-pH+fcont,Xf+pA-fcont,Yi-pH+fcont);
      Line(Xi-pA+fcont,Yi-pH+fcont,Xi-pA+fcont,Yf+pH-fcont);
    End;
End;{----------------------------------------------------------------}

{------------------------- Ejecuta el Boton -------------------------}
Function BotonExe(fC:String;Xi,Yi,fA,fH,fS,ft:Integer):Byte;
Var
  Xf,Yf :Integer;
  Flag  :Boolean;

Begin
  Xf:=Xi+(Length(fC)*8)-2;
  Yf:=Yi+6;
  BotonExe:=0;
  if (reg.cx >= Xi-fA) and (reg.cx <= Xf+fA) and
     (reg.dx >= Yi-fH) and (reg.dx <= Yf+fH) then
     Begin
       RatonOff;{P}
       Flag:=False;
       pON(fC,Xi,Yi,fA,fH,fS);{P}
       if ft = 0 then
         Repeat
           reg.ax:=$03;
           Intr($33,reg);
           if reg.bx<>$01 then
             Flag:=True;
         Until Flag=True
       else
         Delay(50);
       BotonOff(fC,Xi,Yi,fA,fH,fS);{P}
       RatonOn;{P}
       BotonExe:=1;
       Reg.cx:=$00;
       Reg.dx:=$00;
     end;
End;{----------------------------------------------------------------}

Procedure RatonError;{-----------------------------------------------}
Begin
     Fondo(170,160,460,310,1,1,15,8,7);
     Fondo(190,180,440,290,1,6,8,15,12);
     Fondo(210,200,420,270,1,1,15,8,7);
     SetColor(4);
     OutTextXY(221,213,'EL PROGRAMA REQUIERE DEL');
     OutTextXY(221,233,' MOUSE PARA SU CORRECTO');
     OutTextXY(221,253,'    FUNCIONAMIENTO.');
End;{----------------------------------------------------------------}

{--- Inicializa los graficos y el raton. NOTA:Falta CloseGraphics ---}
Procedure IniUtMouV04;
Var
  grDriver,grMode :Integer;
Begin
  grDriver:=Detect;
  InitGraph(grDriver, grMode,' ');
  if GraphResult = grOK then
    Begin
      reg.ax:=$00;
      intr($33,reg);
      if Reg.bx = 0 then
        Begin
          RatonError;
          ReadKey;
          CloseGraph;
          Halt;
        end;
     end
  else
    Begin
      Writeln('Error Cargando Grficos.');
      Halt;
    end;
End;{----------------------------------------------------------------}

Procedure FaceMouse;
Var
  FaceMasks:Array[0..1,0..15] of Word;
  Regs     :Registers;
Begin
  { Screen Mask }
  facemasks[0,0] := $C003;    {1100000000000011}
  facemasks[0,1] := $8001;    {1000000000000001}
  facemasks[0,2] := $0000;    {0000000000000000}
  facemasks[0,3] := $0000;    {0000000000000000}
  facemasks[0,4] := $0000;    {0000000000000000}
  facemasks[0,5] := $03C0;    {0000001111000000}
  facemasks[0,6] := $0180;    {0000000110000000}
  facemasks[0,7] := $07E0;    {0000011111100000}
  facemasks[0,8] := $0660;    {0000011001100000}
  facemasks[0,9] := $03C0;    {0000001111000000}
  facemasks[0,10] := $0000;   {0000000000000000}
  facemasks[0,11] := $0000;   {0000000000000000}
  facemasks[0,12] := $0000;   {0000000000000000}
  facemasks[0,13] := $0000;   {0000000000000000}
  facemasks[0,14] := $8001;   {1000000000000001}
  facemasks[0,15] := $C003;   {1100000000000011}
  { Cursor Mask }
  facemasks[1,0] := $0000;    {0000000000000000}
  facemasks[1,1] := $1FF8;    {0001111111111000}
  facemasks[1,2] := $3FFC;    {0011111111111100}
  facemasks[1,3] := $700E;    {0111000000001110}
  facemasks[1,4] := $67E6;    {0110011111100110}
  facemasks[1,5] := $6FF6;    {0110111111110110}
  facemasks[1,6] := $6996;    {0110100110010110}
  facemasks[1,7] := $6FF6;    {0110111111110110}
  facemasks[1,8] := $6FF6;    {0110111111110110}
  facemasks[1,9] := $6BD6;    {0110101111010110}
  facemasks[1,10] := $6C36;   {0110110000110110}
  facemasks[1,11] := $67E6;   {0110011111100110}
  facemasks[1,12] := $700E;   {0111000000001110}
  facemasks[1,13] := $3FFC;   {0011111111111100}
  facemasks[1,14] := $1FF8;   {0001111111111000}
  facemasks[1,15] := $0000;   {0000000000000000}
  regs.AX := 9;
  regs.BX := 1;
  regs.CX := 0;
  regs.DX := ofs(facemasks);
  regs.ES := seg(facemasks);
  Intr(51,Regs);
End;

Procedure ArrowMouse;
Var
  PijlMasks:Array[0..1,0..15] of Word;
  Regs     :Registers;
Begin
  { Screen Mask }
  pijlmasks[0,0] := $9FFF;    {1001111111111111}
  pijlmasks[0,1] := $8FFF;    {1000111111111111}
  pijlmasks[0,2] := $87FF;    {1000011111111111}
  pijlmasks[0,3] := $83FF;    {1000001111111111}
  pijlmasks[0,4] := $81FF;    {1000000111111111}
  pijlmasks[0,5] := $80FF;    {1000000011111111}
  pijlmasks[0,6] := $807F;    {1000000001111111}
  pijlmasks[0,7] := $803F;    {1000000000111111}
  pijlmasks[0,8] := $801F;    {1000000000011111}
  pijlmasks[0,9] := $800F;    {1000000000001111}
  pijlmasks[0,10] := $80FF;   {1000000011111111}
  pijlmasks[0,11] := $887F;   {1000100001111111}
  pijlmasks[0,12] := $987F;   {1001100001111111}
  pijlmasks[0,13] := $FC3F;   {1111110000111111}
  pijlmasks[0,14] := $FC3F;   {1111110000111111}
  pijlmasks[0,15] := $FE3F;   {1111111000111111}
  { Cursor Mask }
  pijlmasks[1,0] := $0000;    {0000000000000000}
  pijlmasks[1,1] := $2000;    {0010000000000000}
  pijlmasks[1,2] := $3000;    {0011000000000000}
  pijlmasks[1,3] := $3800;    {0011100000000000}
  pijlmasks[1,4] := $3C00;    {0011110000000000}
  pijlmasks[1,5] := $3E00;    {0011111000000000}
  pijlmasks[1,6] := $3F00;    {0011111100000000}
  pijlmasks[1,7] := $3F80;    {0011111110000000}
  pijlmasks[1,8] := $3FC0;    {0011111111000000}
  pijlmasks[1,9] := $3E00;    {0011111000000000}
  pijlmasks[1,10] := $3600;   {0011011000000000}
  pijlmasks[1,11] := $2300;   {0010001100000000}
  pijlmasks[1,12] := $0300;   {0000001100000000}
  pijlmasks[1,13] := $0180;   {0000000110000000}
  pijlmasks[1,14] := $0180;   {0000000110000000}
  pijlmasks[1,15] := $0000;   {0000000000000000}
  regs.AX := 9;
  regs.BX := 1;
  regs.CX := 0;
  regs.DX := ofs(pijlmasks);
  regs.ES := seg(pijlmasks);
  Intr(51,Regs);
End;

Procedure CursorMouse;
Var
  HoeklMasks:Array[0..1,0..15] of Word;
  Regs      :Registers;
Begin
  { Screen Mask }
  hoeklmasks[0,0] := $0000;    {0000000000000000}
  hoeklmasks[0,1] := $0000;    {0000000000000000}
  hoeklmasks[0,2] := $3FFF;    {0011111111111111}
  hoeklmasks[0,3] := $3FFF;    {0011111111111111}
  hoeklmasks[0,4] := $3FFF;    {0011111111111111}
  hoeklmasks[0,5] := $3FFF;    {0011111111111111}
  hoeklmasks[0,6] := $3FFF;    {0011111111111111}
  hoeklmasks[0,7] := $3FFF;    {0011111111111111}
  hoeklmasks[0,8] := $3FFF;    {0011111111111111}
  hoeklmasks[0,9] := $3FFF;    {0011111111111111}
  hoeklmasks[0,10] := $3FFF;   {0011111111111111}
  hoeklmasks[0,11] := $3FFF;   {0011111111111111}
  hoeklmasks[0,12] := $3FFF;   {0011111111111111}
  hoeklmasks[0,13] := $3FFF;   {0011111111111111}
  hoeklmasks[0,14] := $3FFF;   {0011111111111111}
  hoeklmasks[0,15] := $3FFF;   {0011111111111111}
  { Cursor Mask }
  hoeklmasks[1,0] := $FFFF;    {1111111111111111}
  hoeklmasks[1,1] := $8000;    {1000000000000000}
  hoeklmasks[1,2] := $8000;    {1000000000000000}
  hoeklmasks[1,3] := $8000;    {1000000000000000}
  hoeklmasks[1,4] := $8000;    {1000000000000000}
  hoeklmasks[1,5] := $8000;    {1000000000000000}
  hoeklmasks[1,6] := $8000;    {1000000000000000}
  hoeklmasks[1,7] := $8000;    {1000000000000000}
  hoeklmasks[1,8] := $8000;    {1000000000000000}
  hoeklmasks[1,9] := $8000;    {1000000000000000}
  hoeklmasks[1,10] := $8000;   {1000000000000000}
  hoeklmasks[1,11] := $8000;   {1000000000000000}
  hoeklmasks[1,12] := $8000;   {1000000000000000}
  hoeklmasks[1,13] := $8000;   {1000000000000000}
  hoeklmasks[1,14] := $8000;   {1000000000000000}
  hoeklmasks[1,15] := $8000;   {1000000000000000}
  regs.AX := 9;
  regs.BX := 1;
  regs.CX := 0;
  regs.DX := ofs(hoeklmasks);
  regs.ES := seg(hoeklmasks);
  Intr(51,Regs);
End;

Procedure HandMouse;
Var
  HandMasks:Array[0..1,0..15] of Word;
  Regs     :Registers;
Begin
  { Screen Mask }
  handmasks[0,0] := $F3FF;    {1111001111111111}
  handmasks[0,1] := $E1FF;    {1110000111111111}
  handmasks[0,2] := $E1FF;    {1110000111111111}
  handmasks[0,3] := $E1FF;    {1110000111111111}
  handmasks[0,4] := $E1FF;    {1110000111111111}
  handmasks[0,5] := $E07F;    {1110000001111111}
  handmasks[0,6] := $C00F;    {1100000000001111}
  handmasks[0,7] := $8001;    {1000000000000001}
  handmasks[0,8] := $0000;    {0000000000000000}
  handmasks[0,9] := $0000;    {0000000000000000}
  handmasks[0,10] := $0000;   {0000000000000000}
  handmasks[0,11] := $0000;   {0000000000000000}
  handmasks[0,12] := $0000;   {0000000000000000}
  handmasks[0,13] := $8000;   {1000000000000000}
  handmasks[0,14] := $C001;   {1100000000000001}
  handmasks[0,15] := $E001;   {1110000000000001}
  { Cursor Mask }
  handmasks[1,0] := $0000;    {0000000000000000}
  handmasks[1,1] := $0C00;    {0000110000000000}
  handmasks[1,2] := $0C00;    {0000110000000000}
  handmasks[1,3] := $0C00;    {0000110000000000}
  handmasks[1,4] := $0C00;    {0000110000000000}
  handmasks[1,5] := $0C00;    {0000110000000000}
  handmasks[1,6] := $0D80;    {0000110110000000}
  handmasks[1,7] := $2DB0;    {0010110110110000}
  handmasks[1,8] := $6DB6;    {0110110110110110}
  handmasks[1,9] := $6DB6;    {0110110110110110}
  handmasks[1,10] := $6DB6;   {0110110110110110}
  handmasks[1,11] := $7FFE;   {0111111111111110}
  handmasks[1,12] := $7FFE;   {0111111111111110}
  handmasks[1,13] := $3FFE;   {0011111111111110}
  handmasks[1,14] := $1FFC;   {0001111111111100}
  handmasks[1,15] := $0000;   {0000000000000000}
  regs.AX := 9;
  regs.BX := 1;
  regs.CX := 0;
  regs.DX := ofs(handmasks);
  regs.ES := seg(handmasks);
  Intr(51,Regs);
End;

Procedure LoepMouse;
Var
  LoepMasks:Array[0..1,0..15] of Word;
  Regs     :Registers;
Begin
  { Screen Mask }
  loepmasks[0,0] := $E007;    {1110000000000111}
  loepmasks[0,1] := $8001;    {1000000000000001}
  loepmasks[0,2] := $0000;    {0000000000000000}
  loepmasks[0,3] := $0000;    {0000000000000000}
  loepmasks[0,4] := $0000;    {0000000000000000}
  loepmasks[0,5] := $0000;    {0000000000000000}
  loepmasks[0,6] := $8001;    {1000000000000001}
  loepmasks[0,7] := $E007;    {1110000000000111}
  loepmasks[0,8] := $FC3F;    {1111110000111111}
  loepmasks[0,9] := $FC3F;    {1111110000111111}
  loepmasks[0,10] := $FC3F;   {1111110000111111}
  loepmasks[0,11] := $FC3F;   {1111110000111111}
  loepmasks[0,12] := $FC3F;   {1111110000111111}
  loepmasks[0,13] := $FC3F;   {1111110000111111}
  loepmasks[0,14] := $FC3F;   {1111110000111111}
  loepmasks[0,15] := $FE7F;   {1111111001111111}
  { Cursor Mask }
  loepmasks[1,0] := $0000;    {0000000000000000}
  loepmasks[1,1] := $1FF8;    {0001111111111000}
  loepmasks[1,2] := $7F0E;    {0111111100001110}
  loepmasks[1,3] := $7FE6;    {0111111111100110}
  loepmasks[1,4] := $7FF6;    {0111111111110110}
  loepmasks[1,5] := $7FFE;    {0111111111111110}
  loepmasks[1,6] := $1FF8;    {0001111111111000}
  loepmasks[1,7] := $0000;    {0000000000000000}
  loepmasks[1,8] := $0000;    {0000000000000000}
  loepmasks[1,9] := $0180;    {0000000110000000}
  loepmasks[1,10] := $0180;   {0000000110000000}
  loepmasks[1,11] := $0180;   {0000000110000000}
  loepmasks[1,12] := $0180;   {0000000110000000}
  loepmasks[1,13] := $0180;   {0000000110000000}
  loepmasks[1,14] := $0180;   {0000000110000000}
  loepmasks[1,15] := $0000;   {0000000000000000}
  regs.AX := 9;
  regs.BX := 1;
  regs.CX := 0;
  regs.DX := ofs(loepmasks);
  regs.ES := seg(loepmasks);
  Intr(51,Regs);
End;

Procedure CruzMouse;
Var
  HoeklMasks:Array[0..1,0..15] of Word;
  Regs      :Registers;
Begin
  { Screen Mask }
  hoeklmasks[0,0] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,1] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,2] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,3] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,4] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,5] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,6] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,7] :=  $0000;   {0000000000000000}
  hoeklmasks[0,8] :=  $0000;   {0000000000000000}
  hoeklmasks[0,9] :=  $FE7F;   {1111111001111111}
  hoeklmasks[0,10] := $FE7F;   {1111111001111111}
  hoeklmasks[0,11] := $FE7F;   {1111111001111111}
  hoeklmasks[0,12] := $FE7F;   {1111111001111111}
  hoeklmasks[0,13] := $FE7F;   {1111111001111111}
  hoeklmasks[0,14] := $FE7F;   {1111111001111111}
  hoeklmasks[0,15] := $FE7F;   {1111111001111111}
  { Cursor Mask }
  hoeklmasks[1,0] := $0100;    {0000000100000000}
  hoeklmasks[1,1] := $0100;    {0000000100000000}
  hoeklmasks[1,2] := $0100;    {0000000100000000}
  hoeklmasks[1,3] := $0100;    {0000000100000000}
  hoeklmasks[1,4] := $0100;    {0000000100000000}
  hoeklmasks[1,5] := $0100;    {0000000100000000}
  hoeklmasks[1,6] := $0100;    {0000000100000000}
  hoeklmasks[1,7] := $FFFF;    {1111111111111111}
  hoeklmasks[1,8] := $0100;    {0000000100000000}
  hoeklmasks[1,9] := $0100;    {0000000100000000}
  hoeklmasks[1,10] := $0100;   {0000000100000000}
  hoeklmasks[1,11] := $0100;   {0000000100000000}
  hoeklmasks[1,12] := $0100;   {0000000100000000}
  hoeklmasks[1,13] := $0100;   {0000000100000000}
  hoeklmasks[1,14] := $0100;   {0000000100000000}
  hoeklmasks[1,15] := $0100;   {0000000100000000}
  regs.AX := 9;
  regs.BX := 7;
  regs.CX := 7;
  regs.DX := ofs(hoeklmasks);
  regs.ES := seg(hoeklmasks);
  Intr(51,Regs);
End;

End.